poj 1426 Find The Multiple(dfs || 二进制枚举)

2024-03-27 23:38

本文主要是介绍poj 1426 Find The Multiple(dfs || 二进制枚举),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:http://poj.org/problem?id=1426

大意是:给定一个数字n,求出数字m,其中m是n的倍数,且m是只由0,1构成的十进制数。

Sample Input

2
6
19
0

Sample Output

10
100100100100100100
111111111111111111
开始我一直往数论方向想呢···使用单纯的枚举肯定是要超时的,
TLE:
#include <iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
/* run this program using the console pauser or add your own getch, system("pause") or input loop */
using namespace std;
typedef unsigned long long ull;
ull pow(ull a){  //自己定义函数,不要用pow,防止精度问题。ull ans=1;while(a--){ans=ans*10;}return ans;
}
int main(int argc, char *argv[]) {//freopen("cin.txt","r",stdin);int n;ull t=1;while(cin>>n&&n){bool judge=0;for(ull i=1;i<(t<<63);i++){  //所有变量全用ull表示,不然1<<63的结果会超过int的表示范围,会发生怪事儿。ull temp=0;if(judge)break;for(ull j=0;j<63;j++){if((t<<j)&i){temp+=pow(j);if(temp>0&&temp%n==0){printf("%I64u\n",temp);judge=1;break;}}}}}return 0;
}
和同种思路的BFS(TLE~):
#include<iostream>
#include<stdio.h>
#include<queue>
using namespace std;
typedef unsigned long long ull;
void bfs(ull n)
{queue<ull>q;q.push(1);while(!q.empty()){ull x;x=q.front();q.pop();if(x%n==0){printf("%I64u\n",x);return ;}if(x*10>(ull(1)<<63))return ;q.push(x*10);q.push(x*10+1);}
}
int main()
{ull n;while(cin>>n&&n){bfs(n);}return 0;
}
大多数情况下,BFS是比DFS快的,但是这里因为BFS和暴力枚举的思路一样,所以会效率低下。下面的DFS让大数先比较,这样的成功率要高些。
正确的代码:
#include <iostream>
#include <cstdio>
using namespace std;
typedef unsigned long long ull;
bool flag=0;
void dfs(ull number,int n,int count){if(count>19 || flag )return ;if(number%n==0){flag=1;cout<<number<<endl;return ;}dfs(number*10,n,count+1);dfs(number*10+1,n,count+1);
}
int main()
{int n;while(cin>>n&&n){flag=0;dfs(1,n,0);}return 0;
}
同样的,我们用大数线比较,用二进制枚举再写一遍:
#include <iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
/* run this program using the console pauser or add your own getch, system("pause") or input loop */
using namespace std;
typedef unsigned long long ull;
int p[30],top;
void turn(ull a){cout<<"turn: \n";top=0;memset(p,0,sizeof(p));while(a){p[top++]=a%2;a=a/2;}for(int i=top-1;i>=0;i--)cout<<p[i];  cout<<endl;
}
ull pow(ull a){ull ans=1;while(a--){ans=ans*10;}return ans;
}
int main(int argc, char *argv[]) {//freopen("cout.txt","w",stdout);int n;while(cin>>n&&n){ull t=1;for(ull i=(t<<19)-1;i>=n;i--){ull temp=0;//turn(i);for(ull j=18;j>=0&&j<19;j--){ //当j==0后再减1就变成了-1的补码:18446744073709551615if((t<<j)&i){temp+=pow(j);}}if(temp>=n&&temp%n==0){printf("%I64u\n",temp);break;}}}return 0;
}
想用BFS再写一个的,但是我发现因为大数先进的队列输出时输出的不是自己想要的结果。下面的代码对应的二叉树:
ull maxn=1111111111111111111;
void bfs(ull n)
{
    queue<ull>q;
    q.push(maxn);
    q.push(maxn-1);
    while(!q.empty())
    {
        ull x;
        x=q.front();
        q.pop();
        if(x<n)return ;
        if(x%n==0)
        {
            printf("%I64u\n",x);
            return ;
        }
        q.push(x/10);
        q.push(x/10-1);
    }
}
------------------------------------------

很遗憾是吧,它缺乏DFS和二进制枚举的灵活性还浪费空间。




这篇关于poj 1426 Find The Multiple(dfs || 二进制枚举)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/853779

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i